// Generated by CoffeeScript 1.3.3
(function() {
  var DirWriter, Writer, amazon, awssum, mime, path, s3Service,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Writer = require("fstream").Writer;

  path = require("path");

  awssum = require('awssum');

  amazon = awssum.load('amazon/amazon');

  s3Service = awssum.load('amazon/s3').S3;

  mime = require('mime');

  DirWriter = (function(_super) {

    __extends(DirWriter, _super);

    function DirWriter(params, rel) {
      var s3params;
      this.params = params;
      this.rel = rel != null ? rel : "";
      s3params = {
        accessKeyId: this.params.accessKeyId,
        secretAccessKey: this.params.secretAccessKey,
        region: amazon[this.params.region]
      };
      this.s3 = new s3Service(s3params);
      this._pushing = false;
      this._ended = false;
      this._buffer = [];
    }

    DirWriter.prototype.add = function(rel, entry) {
      var newRel;
      if (entry == null) {
        entry = rel;
        rel = "";
      }
      if (entry.type === "Directory") {
        newRel = entry.path.substr(-1 * ((entry.basename || entry.path).length + this.rel.length + 1));
        entry.pipe(new DirWriter(this.params, newRel));
      } else {
        this._buffer.push(entry);
        this._process();
      }
      return this._buffer.length === 0;
    };

    DirWriter.prototype._process = function() {
      var entry, newObject, relPath,
        _this = this;
      if (this._pushing || this._buffer.length === 0) {
        return;
      }
      this._pushing = true;
      entry = this._buffer.shift();
      relPath = entry.path.substr(-1 * ((entry.basename || entry.path).length + this.rel.length + 1));
      this.emit("entry", entry);
      newObject = {
        BucketName: this.params.bucket,
        ContentLength: entry.props.size,
        Body: entry,
        ObjectName: path.join(this.params.baseDir, relPath),
        ContentType: mime.lookup(relPath)
      };
      if (process.platform === "win32") {
        newObject.ObjectName = newObject.ObjectName.replace(/\\/g, "\/");
      }
      entry.on("end", function() {
        _this._pushing = false;
        return _this._process();
      });
      return this.s3.PutObject(newObject, function(err, r) {
        if (err) {
          return _this.emit("error", err);
        } else {
          _this._pushing = false;
          entry.resume();
          _this.emit("drain");
          return _this._process();
        }
      });
    };

    DirWriter.prototype.write = function() {
      return true;
    };

    DirWriter.prototype.end = function() {
      if (!this._ended) {
        this._process();
      }
      return this._ended = true;
    };

    return DirWriter;

  })(Writer);

  module.exports = DirWriter;

}).call(this);
